/*----------------------------------------------------------------------+
|									|
| Copyright , Bentley Systems, Incorporated, 			|
| All rights reserved.							|
|									|
|									|
| Limited permission is hereby granted to reproduce and modify this	|
| copyrighted material provided that the resulting code is used only in |
| conjunction with Bentley Systems products under the terms of the	|
| license agreement provided therein, and that this notice is retained	|
| in its entirety in any such reproduction or modification.		|
|									|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|									|
|   $Workfile:   ViewDecorator $
|   $Revision:  $
|   	$Date:  $
|									|
+----------------------------------------------------------------------*/
#if !defined(MY_VIEW_DECORATOR_H_INCLUDED_)
#define MY_VIEW_DECORATOR_H_INCLUDED_
/*----------------------------------------------------------------------+
|                                                                       |
|   ViewDecorator - ViewDecorator source code. 							|
|                                                                       |
+----------------------------------------------------------------------*/
#include "resource.h"		//	ICON IDs
#include <MicroStationAPI.h>

/*----------------------------------------------------------------------+
|	A view decorator is good for things that may be changing every		|
|	frame/cursor motion, an IViewTransient is good for      			|
|	things that don't change often.                        				|
+----------------------------------------------------------------------*/

struct DisplaySpriteSample : Bentley::Ustn::IViewTransients
{
	int				iconId_;
	ISpriteP        pSprite_;
	DisplaySpriteSample	()	:	pSprite_	(NULL)	{}
	~DisplaySpriteSample	();
	virtual void _DrawTransients (IViewContextP 	context, bool isPreUpdate) override;
	void    DrawSpriteSample	(IViewContextP		context);
	bool	LoadSprite			(int				iconId,
								const char*			dllName);
	bool	LoadSprite			(int				iconId,
								const wchar_t*		dllName);
	bool	LoadSprite			(int				iconId,
								const std::wstring&	dllName)
	{
		return LoadSprite (iconId, dllName.c_str ());
	}
	bool	IconExists			(int				iconId,
								const wchar_t*		dllName);
	bool	IconExists			(int				iconId,
								const std::wstring&	dllName)
	{
		return IconExists (iconId, dllName.c_str ());
	}
};

#endif // !defined(MY_VIEW_DECORATOR_H_INCLUDED_)
